var maxImages = 5000;			// Maximum number of images in database
var includeDirs = true;			// Include subfolders
var switchInterval = 30*60;		// Change the desktop every ...
var cycleInterval = 15;			// Change the displayed image every ...
								// Supported file types
var shuffleImages = false;		// Randomize pictures
var supportedFileTypes = " .jpg .jpeg .jpe .gif .png .bmp ";
var imgStyle = 0;				// Image positioning style 0=system, 1=stretch, 2=tile, 3=centre, 4=maintainAspect, 5=crop
var osXP = false;				// convert to BMP for XP
var currentFilter = 0;			// Current transition filter
var changeWhenHidden = false;	// Change the desktop when hidden
var currentImageFile;			// Used by the Flyout to display the image
var fillYield = 50;				// Yield back to IE every X ms

var imageIndex = -1;
var cycleIndex = -1;
var tRefresh, tRefresh2, startUp;
var aImages;
var tCycleImage;

var gadgetPath = System.Gadget.path;
var charbackslash = new RegExp("\\\\", "g");

System.Gadget.settingsUI = "Settings.html";
System.Gadget.onDock = dockedState;
System.Gadget.onUndock = dockedState;
System.Gadget.Flyout.file = "flyout.html";

var oShell = new ActiveXObject("WScript.Shell");
var oFSO = new ActiveXObject("Scripting.FileSystemObject");

var bDebug = oFSO.FileExists(gadgetPath+"\\debug.txt");
try{
	if (bDebug)
		var debugLogFile = oFSO.OpenTextFile(gadgetPath+"\\debug.txt", 2);
} catch(err) {bDebug = false; debugLog("Open debug.txt error"+err.name+" - "+err.message)}

//detect OS
try{
	var oWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!//./root/cimv2");
	var tmp = oWMI.ExecQuery("Select * From Win32_OperatingSystem Where Primary='true'");
	var eTmp = new Enumerator(tmp);
	if (eTmp.item().Name.toLowerCase().indexOf("windows xp") > -1) {
		osXP = true;
		imgStyle = 4;
	}
	
	var tmp=null;
	var eTmp=null;
	var oWMI=null;
	if (bDebug) debugLog("XP: "+osXP);
} catch(err) {debugLog("detect OS:"+err.name+" - "+err.message)}

var myWallpaper = System.Shell.knownFolderPath("Profile") + (osXP ? "\\Application Data\\Microsoft\\Wallpaper" : "\\AppData\\Local\\Microsoft\\Wallpaper");
var publicPictures = System.Shell.knownFolderPath("PublicPictures");
var myPictures = System.Shell.knownFolderPath("Pictures");
var defaultWallpapers = System.Environment.getEnvironmentVariable("WINDIR") + "\\Web\\Wallpaper";
var currentPath = myPictures;


var Wallpaper, regRoot;

//register ActiveX component
var axDllClass = "WallpaperGadget.Wallpaper";
var axDllCLSID = "{B126D98F-D005-3ED6-AE81-87C05C075A11}";
var axDllAssembly = "Wallpaper";
var axDllVersion = "1.0.2781.33931";
var axDllRuntimeVer = "v2.0.50727";
var axDllFilename = "wallpaper.dll";

if(bDebug) debugLog("Register ActiveX");
if(bDebug) debugLog("trying HKCU");
if (!activeDLL("HKCU")) {
	if(bDebug) debugLog("trying HKLM");
	if (!activeDLL("HKLM"))
		debugLog("Error creating Wallpaper ActiveX object");
}




// shuffle array
Array.prototype.shuffle = function() {
	var elements = this.length;

	// step through the array
	for (var j=0; j<elements; j++)
		this.swap(j, Math.floor(elements * Math.random()));

	return this;
}


// swap array elements
Array.prototype.swap = function(a, b) {
	var tmp = this[a];
	this[a] = this[b];
	this[b] = tmp;
}



// terminate the DLL
function terminate() {
	debugLog("Wallpaper: shutting down gracefully");
	try{Wallpaper.Terminate()} catch(err) {debugLog("Can't dispose of Wallpaper DLL")}

	Wallpaper = null;

	unregisterDLL();
	debugLog("Wallpaper: shut down gracefully");
}



// Register DLL
function registerDLL() {
	try{
		var classRoot = regRoot + "\\Software\\Classes\\" + axDllClass + "\\";
		var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + axDllCLSID + "\\";
		var dllPath = System.Gadget.path.replace(RegExp("\\\\", "g"), "/") + "/" + axDllFilename;

		oShell.RegWrite(classRoot, axDllClass, "REG_SZ");
		oShell.RegWrite(classRoot + "CLSID\\", axDllCLSID, "REG_SZ");
		oShell.RegWrite(clsidRoot, axDllClass, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\", "mscoree.dll", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\ThreadingModel", "Both", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\Class", axDllClass, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\Assembly", axDllAssembly + ", Version=" + axDllVersion + ", Culture=neutral, PublicKeyToken=null", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\RuntimeVersion", axDllRuntimeVer, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\CodeBase", "file:///" + dllPath, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\Class", axDllClass, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\Assembly", axDllAssembly + ", Version=" + axDllVersion + ", Culture=neutral, PublicKeyToken=null", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\RuntimeVersion", axDllRuntimeVer, "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\CodeBase", "file:///" + dllPath, "REG_SZ");
		oShell.RegWrite(clsidRoot + "ProgId\\", axDllClass, "REG_SZ");
		oShell.RegWrite(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\", "", "REG_SZ");
	} catch(err) {debugLog("registerDLL: "+err.name+" - "+err.message)}
}



// Unregister DLL
function unregisterDLL() {
	try{		
		var classRoot = regRoot + "\\Software\\Classes\\" + axDllClass + "\\";
		var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + axDllCLSID + "\\";

		oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\");
		oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\");
		oShell.RegDelete(clsidRoot + "ProgId\\");
		oShell.RegDelete(clsidRoot + "InprocServer32\\" + axDllVersion + "\\");
		oShell.RegDelete(clsidRoot + "InprocServer32\\");
		oShell.RegDelete(clsidRoot);
		oShell.RegDelete(classRoot + "CLSID\\");
		oShell.RegDelete(classRoot);
	} catch(err) {debugLog("unregisterDLL: "+err.name+" - "+err.message)}
}



// Try to register the DLL
function activeDLL(root) {
	regRoot = root;

	try{
		registerDLL();
		Wallpaper = new ActiveXObject(axDllClass);
		return true;
	} catch(err) {
		Wallpaper = null;
		unregisterDLL();
	}

	return false;
}



//log a debug entry
function debugLog(str) {
	try{
		System.Debug.outputString(str);
		if (bDebug)
			debugLogFile.WriteLine(str);
	} catch(err) {}
}



// Initialize the Gadget
function startUpGadget() {
	try{
		// show the loading screen
		BP_Loading();

		startUp = true;

		//restore settings
		if (System.Gadget.Settings.readString("currentPath") != "")
		{
			currentPath = System.Gadget.Settings.readString("currentPath");
			switchInterval = System.Gadget.Settings.read("switchInterval");
			cycleInterval = System.Gadget.Settings.read("cycleInterval");
			includeDirs = System.Gadget.Settings.read("includeDirs");
			shuffleImages = System.Gadget.Settings.read("shuffleImages");
			imgStyle = System.Gadget.Settings.read("imgStyle");
			cycleIndex = System.Gadget.Settings.read("cycleIndex")-1;
			imageIndex = System.Gadget.Settings.read("imageIndex")-1;
			currentFilter = System.Gadget.Settings.read("currentFilter");
			changeWhenHidden = System.Gadget.Settings.read("changeWhenHidden");
		}

		window.setTimeout("initArray(false)", 500);
	} catch(err) {debugLog("startUpGadget: "+err.name+" - "+err.message)}
}


// Initialize the image array
var dirChanged;
function initArray(i) {
	try{window.clearTimeout(tRefresh)} catch(err) {debugLog("Cancel timer: "+err.name+ " - "+err.message)}
	try{window.clearTimeout(tRefresh2)} catch(err) {debugLog("Cancel timer2: "+err.name+ " - "+err.message)}

	try{
		dirChanged = i;

		// show the loading screen
    	imgFrame.style.display = "none";
		BP_Loading();

		aImages = new Array();
		dirArray = new Array();
		catalogueImages(currentPath);
	} catch(err) {debugLog("initArray: " + err.name + " - " + err.message)}
}



// Catalogue the images in the selected folder
var dirArray;
var oItems = new Array();
var catIndex = 0;
function catalogueImages(filePath) {
	try{
		//stop getting images if we have too many
		if (aImages.length >= maxImages) return;

		if (filePath != null || catIndex == oItems.count) {
			if (filePath == null)
				filePath = dirArray.pop();

			if (bDebug) debugLog("scanning "+ filePath);

			//get the folder
			try{
				var oFolder = System.Shell.itemFromPath(filePath); 
			} catch(err) {debugLog("catalogueImages1: "+err.name+" - "+err.message); return;}

			//dont look in compressed folders
			if(oFolder.type == "Compressed (zipped) Folder") {
				if (dirArray.length>0)
					window.setTimeout(catalogueImages, 20);
				else
					catalogueImagesFinished();

				return;
			}
	
			//get the files in the folder
			oItems = oFolder.SHFolder.Items;
			catIndex = 0;
		}

		var sFiletype, sFile;

		var counter = new Date();
		while (catIndex<oItems.count && aImages.length<maxImages && (new Date())-counter<fillYield)
		{
			try{
				sFile = oItems.item(catIndex).path;
		
				if (!oItems.item(catIndex).isFolder && !oItems.item(catIndex).isLink) {
					//file
					sFiletype = sFile.substr(sFile.lastIndexOf(".")).toLowerCase();

					//is the filetype supported
		            if(supportedFileTypes.indexOf(" " + sFiletype + " ") > -1) {
						if (bDebug) debugLog("file: "+sFile);
						aImages.push(sFile);
					}
		        } else if (includeDirs && oItems.item(catIndex).isFolder) {
		        	//folder
		        	dirArray.push(sFile);
				}
			} catch(err) {debugLog("catalogueImages2: "+err.name+" - "+err.message)}
			catIndex++;
	    }

	    if ((dirArray.length>0 || catIndex<oItems.count) && aImages.length<maxImages)
	    	window.setTimeout(catalogueImages, 20);
	    else
	    	catalogueImagesFinished();
	} catch(err) {debugLog("catalogueImages3: "+err.name+" - "+err.message)}
}

function catalogueImagesFinished() {
	try{
    	// remove the loading screen
    	BP_Loading(100);
    	dockedState();
    	imgFrame.style.display = "inline";

		//if we have images, setup the timers and display the 1st picture
		if (aImages.length>0)
		{
			if (shuffleImages) aImages.shuffle();
	
			if (imageIndex>aImages.length || dirChanged) imageIndex = -1;
			if (cycleIndex>aImages.length || dirChanged) cycleIndex = -1;
	
			displayNext(true);
			setupTimers();
		} else {
			//if there's no images, use the windows wallpaper folder
			currentPath = defaultWallpapers;
			catalogueImages(currentPath);
		}

    	startUp = false;
	} catch(err) {debugLog("catalogueImagesFinished: "+err.name+" - "+err.message)}
}


// Setup the update Timer
function setupTimers() {
	//clear timers
	try{window.clearTimeout(tRefresh)} catch(err) {debugLog("Cancel timer: "+err.name+ " - "+err.message)}
	try{window.clearTimeout(tRefresh2)} catch(err) {debugLog("Cancel timer2: "+err.name+ " - "+err.message)}

	//create desktop change timers
	tRefresh = window.setInterval(displayNext, switchInterval * 1000);

	//create slideshow timer only if we're not in preview next mode
	if (cycleInterval == 0)
		imageIndex = cycleIndex-1;
	else
		tRefresh2 = window.setInterval("displayNext(true)", cycleInterval * 1000);
}



// Display the previous image
function displayPrevious() {
	// check if we're in a Remote Desktop session
	if (remoteDesktop()) return;

	if (cycleIndex-- == 0) cycleIndex = aImages.length - 1;

	startTransition();
	currentImageFile = aImages[cycleIndex];
	imgSrc.src = scaleImage(aImages[cycleIndex], false) + "?" + Math.random();

	scaleGadgetImage();
	System.Gadget.Settings.write("cycleIndex", cycleIndex);
	if (cycleInterval == 0) {
		imageIndex = cycleIndex-1;
		System.Gadget.Settings.write("imageIndex", imageIndex);
	}
	refreshFlyout();
}



// Display the next image
function displayNext(setImage) {
	try{
		if (!System.Gadget.visible && !changeWhenHidden && !startUp) return;
	
		// check if we're in a Remote Desktop session
		if (remoteDesktop() && !startUp) return;

		//go to the next image
		if (!setImage) {	// set the Desktop
			if (imageIndex++ == aImages.length-1) imageIndex = 0;
			System.Gadget.Settings.write("imageIndex", imageIndex);
	
			setWallpaper(true);
			if (cycleInterval == 0) cycleIndex=imageIndex;
		}
	
		if (setImage || cycleInterval == 0) {
			if (cycleIndex++ == aImages.length-1) cycleIndex = 0;
			System.Gadget.Settings.write("cycleIndex", cycleIndex);

			startTransition();
			//change the image
			currentImageFile = aImages[cycleIndex];
			imgSrc.src = scaleImage(aImages[cycleIndex], false) + "?" + Math.random();

			//scale the image and apply the transition
			scaleGadgetImage();
			if (cycleInterval == 0) imageIndex=cycleIndex-1;

			refreshFlyout();
		}
	} catch(err) {debugLog("displayNext: "+err.name+" - "+err.message)}
}



//start the transition filter
function startTransition() {
	try{
		if (currentFilter>0) {
			imgFrame.style.filter = "progid:DXImageTransform.Microsoft.RevealTrans";
			imgFrame.filters[0].transition = currentFilter-1;
			imgFrame.filters[0].duration = 0.5;
			imgFrame.filters[0].Apply();
		}
	} catch(err) {debugLog("startTransition: "+err.name+" - "+err.message)}
}


// Set the Gadget image (workaround maxWidth/Height not working correctly in IE7)
function scaleGadgetImage() {
	var img = new Image();
	img.src = imgSrc.src;

	if (img.width+img.height > 0)
	{
		imgSrc.style.width = null;
		imgSrc.style.height = null;
	
		var tmpWidth = img.width;
		var tmpHeight = img.height;
		var maxWidth = parseInt(imgSrc.style.maxWidth);
		var maxHeight = parseInt(imgSrc.style.maxHeight);
	
		if (tmpWidth > maxWidth) {
			tmpHeight = tmpHeight * maxWidth / tmpWidth;
			tmpWidth = maxWidth;
		}
		if (tmpHeight > maxHeight) {
			tmpWidth = tmpWidth * maxHeight / tmpHeight;
			tmpHeight = maxHeight;
		}

		if (imgStyle == 1) { //stretch
			imgSrc.style.width = imgSrc.style.maxWidth;
			imgSrc.style.height = imgSrc.style.maxHeight;
		} else {
			imgSrc.style.width = Math.round(tmpWidth);
			imgSrc.style.height = Math.round(tmpHeight);
		}

		//apply the transition
		if (currentFilter>0) imgFrame.filters[0].Play();
	} else
		window.setTimeout(scaleGadgetImage, 100);

	img = null;
}



// Set the desktop wallpaper
function setWallpaper(setImage) {
	// check if we're in a Remote Desktop session
	if (remoteDesktop()) return;

	try{
		if (setImage)
			scaleImage(aImages[imageIndex], true);
		else {
			if (bDebug) debugLog(aImages[cycleIndex]);
			scaleImage(aImages[cycleIndex], true);
			imageIndex = cycleIndex;
			if (cycleInterval == 0) displayNext(true);
		}
	} catch(err) {debugLog("setWallpaper: "+err.name+" - "+err.message)}
}



function scaleImage(sFilename, setDesktop) {
	if (!oFSO.FileExists(sFilename)) return;

	try{
		var lFilename = myWallpaper + (setDesktop ? "1." : "2.");
	
		//use BMP if we're running in XP
		if (osXP) {
			lFilename += "bmp";
			if (imgStyle!=4 && imgStyle!=5) imgStyle = 4;
		} else
			lFilename += "jpg";
	
		//set the current user positioning values for the standard styles
		if (setDesktop) {
			switch(imgStyle)
			{
				case 1: //stretch
					oShell.RegWrite("HKCU\\Control Panel\\Desktop\\WallpaperStyle","2", "REG_SZ");
					oShell.RegWrite("HKCU\\Control Panel\\Desktop\\TileWallpaper","0", "REG_SZ");
					break;
				case 2: //tile
					oShell.RegWrite("HKCU\\Control Panel\\Desktop\\WallpaperStyle","1", "REG_SZ");
					oShell.RegWrite("HKCU\\Control Panel\\Desktop\\TileWallpaper","1", "REG_SZ");
					break;
				case 3: //centre
					oShell.RegWrite("HKCU\\Control Panel\\Desktop\\WallpaperStyle","1", "REG_SZ");
					oShell.RegWrite("HKCU\\Control Panel\\Desktop\\TileWallpaper","0", "REG_SZ");
					break;
			}
		}

		var gWidth = parseInt(imgSrc.style.maxWidth);
		var gHeight = parseInt(imgSrc.style.maxHeight);

		if (osXP || imgStyle == 4) {					// maintain aspect ratio
			if (setDesktop) {
				if (bDebug) debugLog("Generating (MA): " + lFilename);
				if (bDebug) debugLog("           from: " + sFilename);
				Wallpaper.ScaleImage(sFilename, lFilename);
				if (bDebug) {
					if (!oFSO.FileExists(lFilename)) debugLog("Failed");
					debugLog("Setting Wallpaper: " + lFilename);
				}
				Wallpaper.SetWallpaper(lFilename);
				if (bDebug) debugLog("Setting Wallpaper Complete");
			} else {
				if (bDebug) debugLog("Generating (MA): " + lFilename);
				if (bDebug) debugLog("           from: " + sFilename);
				Wallpaper.ScaleImage(sFilename, lFilename, gWidth, gHeight);
				if (bDebug) {
					if (!oFSO.FileExists(lFilename)) debugLog("Failed");
				}
				return lFilename;
			}
		} else if (imgStyle == 5) {						// crop to fit screen
			if (setDesktop) {
				if (bDebug) debugLog("Generating (CR): " + sFilename);
				Wallpaper.CropImage(sFilename, lFilename);
				if (bDebug) {
					if (!oFSO.FileExists(lFilename)) debugLog("Failed");
					debugLog("Setting Wallpaper: " + lFilename);
				}
				Wallpaper.SetWallpaper(lFilename);
				if (bDebug) debugLog("Complete");
			} else {
				if (bDebug) debugLog("Generating (CR): " + sFilename);
				Wallpaper.CropImage(sFilename, lFilename, gWidth, gHeight);
				if (bDebug) {
					if (!oFSO.FileExists(lFilename)) debugLog("Failed");
				}
				return lFilename;
			}
		} else if (setDesktop) {						// all other styles
			if (bDebug) debugLog("Setting Wallpaper: " + sFilename);
			Wallpaper.SetWallpaper(sFilename);
			if (bDebug) debugLog("Complete");
		}

		return sFilename;
	} catch(err) {debugLog("scaleImage: "+err.name+" - "+err.message)}
}



// scale the gadget according to it's docked state
function dockedState() {
	try{
		System.Gadget.beginTransition();
		
		if (System.Gadget.docked) {
			document.body.style.width = 130;
			document.body.style.height = 106;
		} else {
			document.body.style.width = 338;
			document.body.style.height = 272;
		}
	
		if (startUp) {
			System.Gadget.endTransition(System.Gadget.TransitionType.none, 0);
			fixZoom();
		} else {
			System.Gadget.endTransition(System.Gadget.TransitionType.morph, 0.2);
			window.setTimeout("fixZoom(true)", 300);
		}
	} catch(err) {
		debugLog("dockedState: " + err.name + " - " + err.message)
		System.Gadget.endTransition(System.Gadget.TransitionType.none, 0);
		fixZoom();
	}
}



// begin/endTransition corrupt the image, so we change the scale after the transition
function fixZoom(bResize) {
	try{
		if (System.Gadget.docked) {
			System.Gadget.background = "images/background.png";
			imgFrame.style.top = 5;
			imgFrame.style.left = 4;
			imgFrame.style.width = 121;
			imgFrame.style.height = 98;
			imgSrc.style.maxWidth = 121;
			imgSrc.style.maxHeight = 98;
			divMenu.style.top = 76;
		} else {
			System.Gadget.background = "images/backgroundLarge.png";
			imgFrame.style.top = 9;
			imgFrame.style.left = 9;
			imgFrame.style.width = 320;
			imgFrame.style.height = 256;
			imgSrc.style.maxWidth = 320;
			imgSrc.style.maxHeight = 256;
			divMenu.style.top = 234;
		}

		// rebuild the image if necessary
		if (bResize)
			imgSrc.src = scaleImage(aImages[cycleIndex], false) + "?" + Math.random();
			
		scaleGadgetImage();
	} catch(err) {debugLog("fixZoom: " + err.name + " - " + err.message)}
}



// Play a move if it's dropped on the Gadget
function fileDragDropped() {
	try{
		Wallpaper.StopVideo();
		for (var i=0; System.Shell.itemFromFileDrop(event.dataTransfer, i) != null; i++)
			debugLog("HWND: "+Wallpaper.PlayVideo(System.Shell.itemFromFileDrop(event.dataTransfer, i).path));
	
	} catch(err) {debugLog("drag:"+err.name+" - "+err.message)}
}



// Are we running on a remote desktop?
function remoteDesktop() {
	try{
		if (oShell.RegRead("HKCU\\Volatile Environment\\1\\CLIENTNAME") != "")
			return true;
	} catch (err) {return false}
}



// Cycle though the images when the mouse is held on previous/next
function cycleImage(bPrevious) {
	if (bPrevious == null) {
		try{window.clearTimeout(tCycleImage)} catch(err) {}
		setupTimers(true);
		return;
	}

	tCycleImage = window.setTimeout("cycleImage(" + bPrevious + ")", 500);

	if (bPrevious)
		displayPrevious();
	else
		displayNext(true);
}



// Refresh the flyout if it's open
function refreshFlyout() {
	if (System.Gadget.Flyout.show) {
		try{
			System.Gadget.Flyout.document.parentWindow.refreshFlyout();
		} catch(err) {}
	}
}